#include "CUnit.h"
#include "CF.h"
#include <stdio.h>
#include <stdlib.h>

int main(){
  printHeader();

  testStart("newCF");
  CF cf1 = cfNewCF();
  assertCFEq("",cf1,cf1);

  char* showcf = cfShowCF(cf1);
  assertStringEq("","| | | | | | | |\n| | | | | | | |\n| | | | | | | |\n| | | | | | | |\n| | | | | | | |\n| | | | | | | |\n",showcf);
  free(showcf);
  
  assertTrue("",cfIsMove(cf1,1));
  assertTrue("",cfIsMove(cf1,7));
  assertTrue("",!cfIsMove(cf1,0));
  assertTrue("",!cfIsMove(cf1,8));
  testEnd();
  testStart("makeMove 1");  
  CF cf2 = cfMakeMove(cf1,1);
  cfDeleteCF(cf1);

  showcf = cfShowCF(cf2);
  assertStringEq("","| | | | | | | |\n| | | | | | | |\n| | | | | | | |\n| | | | | | | |\n| | | | | | | |\n|O| | | | | | |\n",showcf);
  free(showcf);
  testEnd();
  testStart("makeMove 2");  
  
  cf1 = cfMakeMove(cf2,1);
  cfDeleteCF(cf2);
  cf2 = cfMakeMove(cf1,1);
  cfDeleteCF(cf1);

  showcf = cfShowCF(cf2);
  assertStringEq("","| | | | | | | |\n| | | | | | | |\n| | | | | | | |\n|O| | | | | | |\n|X| | | | | | |\n|O| | | | | | |\n",showcf);
  free(showcf);
  testEnd();
  testStart("makeMove 3");  

  cf1 = cfMakeMove(cf2,1);
  cfDeleteCF(cf2);
  cf2 = cfMakeMove(cf1,1);
  cfDeleteCF(cf1);

  showcf = cfShowCF(cf2);
  assertStringEq("","| | | | | | | |\n|O| | | | | | |\n|X| | | | | | |\n|O| | | | | | |\n|X| | | | | | |\n|O| | | | | | |\n",showcf);
  free(showcf);

  testEnd();
  testStart("makeMove 4");  
  
  cf1 = cfMakeMove(cf2,1);
  cfDeleteCF(cf2);
  assertTrue("",!cfIsMove(cf1,1));

  cf2 = cfMakeMove(cf1,2);
  cfDeleteCF(cf1);

  showcf = cfShowCF(cf2);
  assertStringEq("","|X| | | | | | |\n|O| | | | | | |\n|X| | | | | | |\n|O| | | | | | |\n|X| | | | | | |\n|O|O| | | | | |\n",showcf);
  free(showcf);

    testEnd();
  testStart("makeMove 5");  
  
  cf1 = cfMakeMove(cf2,2);
  cfDeleteCF(cf2);
  cf2 = cfMakeMove(cf1,3);
  cfDeleteCF(cf1);

  showcf = cfShowCF(cf2);
  assertStringEq("","|X| | | | | | |\n|O| | | | | | |\n|X| | | | | | |\n|O| | | | | | |\n|X|X| | | | | |\n|O|O|O| | | | |\n",showcf);
  free(showcf);

  testEnd();
  testStart("makeMove 6");  
  
  cf1 = cfMakeMove(cf2,3);
  cfDeleteCF(cf2);
  cf2 = cfMakeMove(cf1,4);
  cfDeleteCF(cf1);

  showcf = cfShowCF(cf2);
  assertStringEq("","|X| | | | | | |\n|O| | | | | | |\n|X| | | | | | |\n|O| | | | | | |\n|X|X|X| | | | |\n|O|O|O|O| | | |\n",showcf);
  free(showcf);

  testEnd();
  testStart("makeMove 7");  
  
  assertTrue("Gewinner nicht erkannt",cfHasWinner(cf2));
  assertTrue("Spielende nicht erkannt",!cfFinished(cf2));


  showcf = cfShowCF(cf2);
  assertStringEq("","|X| | | | | | |\n|O| | | | | | |\n|X| | | | | | |\n|O| | | | | | |\n|X|X|X| | | | |\n|O|O|O|O| | | |\n",showcf);
  free(showcf);
  cfDeleteCF(cf2);

  testEnd();
  testStart("makeMove 8");  
  cf1 = cfNewCF();
  cf2 = cfMakeMove(cf1,5);
  cfDeleteCF(cf1);
  cf1 = cfMakeMove(cf2,4);
  cfDeleteCF(cf2);
  cf2 = cfMakeMove(cf1,4);
  cfDeleteCF(cf1);
  cf1 = cfMakeMove(cf2,3);
  cfDeleteCF(cf2);
  cf2 = cfMakeMove(cf1,2);
  cfDeleteCF(cf1);
  cf1 = cfMakeMove(cf2,3);
  cfDeleteCF(cf2);
  cf2 = cfMakeMove(cf1,3);
  cfDeleteCF(cf1);
  cf1 = cfMakeMove(cf2,2);
  cfDeleteCF(cf2);
  cf2 = cfMakeMove(cf1,1);
  cfDeleteCF(cf1);
  cf1 = cfMakeMove(cf2,2);
  cfDeleteCF(cf2);
  cf2 = cfMakeMove(cf1,2);
  cfDeleteCF(cf1);
  
  showcf = cfShowCF(cf2);
  assertStringEq("","| | | | | | | |\n| | | | | | | |\n| |O| | | | | |\n| |X|O| | | | |\n| |X|X|O| | | |\n|O|O|X|X|O| | |\n",showcf);
  free(showcf);
  assertTrue("",cfIsMove(cf2,7));
  assertTrue("Gewinner nicht erkannt",cfHasWinner(cf2));
  cfDeleteCF(cf2);  
  testEnd();
  printResults();
  printStorage();

  printFoot();
  return EXIT_SUCCESS;

}